"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.whisper = exports.status = exports.resume = exports.renderPath = exports.pause = exports.freeze = void 0;
var kleur_1 = __importDefault(require("kleur"));
var i_1 = __importDefault(require("./i"));
var parseString_1 = __importDefault(require("./parseString"));
var home_1 = __importDefault(require("./home"));
var root_1 = __importDefault(require("./root"));
var cahceTime = [0, ''];
var cacheType = new Map();
var regHome = new RegExp("^" + (0, home_1.default)().replace(/\\/g, '\\\\'), 'g');
var regRoot = new RegExp("^" + (0, root_1.default)().replace(/\\/g, '\\\\'), 'g');
var separator = kleur_1.default.gray('›') + " ";
var status = {
    isFrozen: false,
    isSilent: false,
};
exports.status = status;
var freeze = function (callback) { return __awaiter(void 0, void 0, void 0, function () {
    var result, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                status.isFrozen = true;
                status.isSilent = true;
                if (!(typeof callback === 'function')) return [3, 2];
                return [4, callback()];
            case 1:
                _a = _b.sent();
                return [3, 4];
            case 2: return [4, callback];
            case 3:
                _a = _b.sent();
                _b.label = 4;
            case 4:
                result = _a;
                status.isFrozen = false;
                status.isSilent = false;
                return [2, result];
        }
    });
}); };
exports.freeze = freeze;
var main = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a = args.length === 1
        ? ['default', args[0]]
        : args, type = _a[0], message = _a[1];
    if (!status.isSilent)
        return message;
    var msg = (0, parseString_1.default)(message).trim();
    if (!msg)
        return message;
    (0, i_1.default)(render(type, msg));
    return message;
};
var makeTime = function () {
    var date = new Date();
    return [
        date.getHours(),
        date.getMinutes(),
        date.getSeconds(),
    ]
        .map(function (it) { return it.toString().padStart(2, '0'); })
        .join(':');
};
var pause = function () {
    if (status.isFrozen)
        return;
    status.isSilent = true;
};
exports.pause = pause;
var render = function (type, message) { return [
    renderTime(),
    separator,
    renderType(type),
    renderContent(message),
].join(''); };
var renderContent = function (input) { return renderPath(input)
    .replace(/'.*?'/g, function (text) { return kleur_1.default.magenta(text.replace(/'/g, '') || "''"); }); };
var renderPath = function (input) { return input
    .replace(regRoot, '.')
    .replace(regHome, '~'); };
exports.renderPath = renderPath;
var renderTime = function () {
    var ts = Math.floor(Date.now() / 1e3);
    if (ts === cahceTime[0])
        return cahceTime[1];
    var result = kleur_1.default.gray("[" + makeTime() + "]") + " ";
    cahceTime[0] = ts;
    cahceTime[1] = result;
    return result;
};
var renderType = function (type) {
    var key = type.trim().toLowerCase();
    if (key === 'default')
        return '';
    if (cacheType.has(key))
        return cacheType.get(key);
    var content = [
        kleur_1.default.cyan().underline(key),
        ' '.repeat(Math.max(10 - key.length, 0)),
    ].join('');
    cacheType.set(key, content);
    return content;
};
var resume = function () {
    if (status.isFrozen)
        return;
    status.isSilent = false;
};
exports.resume = resume;
var whisper = function (callback) { return __awaiter(void 0, void 0, void 0, function () {
    var result, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                pause();
                if (!(typeof callback === 'function')) return [3, 2];
                return [4, callback()];
            case 1:
                _a = _b.sent();
                return [3, 4];
            case 2: return [4, callback];
            case 3:
                _a = _b.sent();
                _b.label = 4;
            case 4:
                result = _a;
                resume();
                return [2, result];
        }
    });
}); };
exports.whisper = whisper;
exports.default = main;
